<?php

/*

Plugin Name: GeotagPhoto

Plugin URI: http://www.placemarkers.co.uk

Description: enables all photos with geotag information to be clicked on to show where they were taken.

Version: 0.8.2

Author: Dave Stivens

Author URI: http://www.placemarkers.co.uk

*/



/*  Copyright 2009  Dave Stivens  



    This program is free software; you can redistribute it and/or modify

    it under the terms of the GNU General Public License as published by

    the Free Software Foundation; either version 2 of the License, or

    (at your option) any later version.



    This program is distributed in the hope that it will be useful,

    but WITHOUT ANY WARRANTY; without even the implied warranty of

    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

    GNU General Public License for more details.



    You should have received a copy of the GNU General Public License

    along with this program; if not, write to the Free Software

    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/


global $geotagphoto_options;

$geotagphoto_options = get_option("geotagphoto_options");



	add_filter("the_content", "tagContent" );

	add_action('wp_head', 'thickboxmap_java');

	add_action('loop_end', 'thickboxmap_div');

	add_action('admin_menu', 'geotagphoto_menu');


function exifToNumber($value, $format) {
	$spos = strpos($value, '/');
	if ($spos === false) {
		return sprintf($format, $value);
	} else {
		list($base,$divider) = split("/", $value, 2);
		if ($divider == 0) 
			return sprintf($format, 0);
		else
			return sprintf($format, ($base / $divider));
	}
}

function exifToCoordinate($reference, $coordinate) {
	if ($reference == 'S' || $reference == 'W')
		$prefix = '-';
	else
		$prefix = '';
		
	return $prefix . sprintf('%.6F', exifToNumber($coordinate[0], '%.6F') +
		(((exifToNumber($coordinate[1], '%.6F') * 60) +	
		(exifToNumber($coordinate[2], '%.6F'))) / 3600));
}

function getCoordinates($filename) {
	if (extension_loaded('exif')) {
		$exif = exif_read_data($filename, 'EXIF');
		
		if (isset($exif['GPSLatitudeRef']) && isset($exif['GPSLatitude']) && 
			isset($exif['GPSLongitudeRef']) && isset($exif['GPSLongitude'])) {
			return array (
				exifToCoordinate($exif['GPSLatitudeRef'], $exif['GPSLatitude']), 
				exifToCoordinate($exif['GPSLongitudeRef'], $exif['GPSLongitude'])
			);
		}
	}
}

function coordinate2DMS($coordinate, $pos, $neg) {
	$sign = $coordinate >= 0 ? $pos : $neg;
	
	$coordinate = abs($coordinate);
	$degree = intval($coordinate);
	$coordinate = ($coordinate - $degree) * 60;
	$minute = intval($coordinate);
	$second = ($coordinate - $minute) * 60;
	
	return sprintf("%s %d&#xB0; %02d&#x2032; %05.2f&#x2033;", $sign, $degree, $minute, $second);
}

	function tagContent($content="") 
	{

		$URL = get_bloginfo('wpurl');
		
		$geotagphoto_box = get_option("geotagphoto_box");
		$geotagphoto_icon_pos = get_option("geotagphoto_icon_pos");
		$geotagphoto_icon = get_option("geotagphoto_icon");
		$geotagphoto_map_width = get_option("geotagphoto_map_width"); 
		$geotagphoto_map_height = get_option("geotagphoto_map_height");
		$geotagphoto_map_control = get_option("geotagphoto_map_control"); 
		$geotagphoto_map_control_pos = get_option("geotagphoto_map_control_pos");
		$geotagphoto_map_type = get_option("geotagphoto_map_type");
		$geotagphoto_map_type_sel = get_option("geotagphoto_map_type_sel");
		$geotagphoto_map_zoom = get_option("geotagphoto_map_zoom");		


		switch( $geotagphoto_icon_pos )
		{
			case "TopLeft":
					$IconPos = "top:0px; left:0px;";
			break;
			
			case "TopRight":
					$IconPos = "top:0px; right:0px;";
			break;
			
			case "BottomLeft":
				$IconPos = "bottom:0px; left:0px;";
			break;
			
			case "BottomRight":
				$IconPos = "bottom:0px; right:0px;";
			break;
			
			default:
				$IconPos = "top:0px; left:0px;";
			break;
		}
			
		$post_id = $post->ID;

		global $post;

		preg_match_all("/<img[^>]+src=['\"]*([^'\" ]*)['\" ][^>]*>/i", $post->post_content, $result); 

		foreach( $result[1] as $key => $image ) 
		{			
			if( !file_exists( $image ) )
			{
				$finalpath = str_replace( $URL, $_SERVER["DOCUMENT_ROOT"], $image);			
			}
			else
			{
				$finalpath = $image;	
			}

			if( file_exists( $finalpath ) )
			{
                if( $c = getCoordinates( $finalpath ) ) 
                {
                	$lat = $c[0];
                    $lon = $c[1];

     				$CurTypeOn = "'pointer'";

					if( empty( $geotagphoto_icon ) )
					{
						$geotagphoto_icon =	get_bloginfo('wpurl') . '/wp-content/plugins/geotagphoto/images/marker.png';
					}

                    if( empty( $geotagphoto_map_type_sel ) )
                    {
                        $geotagphoto_map_type_sel = 2;
                    }

					$exif = exif_read_data( $finalpath, 0, true );
					
					$Map = 'onclick="gload( ' . $lat . ',' . $lon .' , ' . $geotagphoto_map_height . ' , ' . $geotagphoto_map_width . ' , ' . $geotagphoto_map_control . ' , ' . $geotagphoto_map_control_pos . ' , ' . $geotagphoto_map_type . ' , ' . $geotagphoto_map_type_sel . ' , ' . $geotagphoto_map_zoom . ');" ';

					$content = ereg_replace( $result[0][ $key ], '<div style="padding:14px; position:relative;  top:0; left:0; z-index:3;"><div style=" margin-left: auto ; margin-right: auto ;padding:0px; position:relative; top:0; left:0; height:' . $exif[ COMPUTED ][ Height ] . 'px; width:' .  $exif[ COMPUTED ][ Width ] . 'px; z-index:4;"><a href="' . $image . '" class="thickbox"><img src="' . $image . '" ></a><div style="position:absolute;  padding:0px; z-index:5;' . $IconPos .'"><img src="' . $geotagphoto_icon . '" ' . $Map . 'onmouseover="this.style.cursor=' . $CurTypeOn . ';" ></div></div></div>', $content );
				}
				else
				{
					if( $geotagphoto_box == "ThickBoxAll" )
					{
						$content = ereg_replace( $result[0][ $key ], '<a href="' . $image . '" class="thickbox">' . $result[0][ $key ] . ' </a>', $content );
					}
				}
			}
			else
			{
				if( $geotagphoto_box == "ThickBoxAll" )
				{
					$content = ereg_replace( $result[0][ $key ], '<a href="' . $image . '" class="thickbox">' . $result[0][ $key ] . ' </a>', $content );
				}	
			}
		}

		return $content;

	}


	function thickboxmap_java() 

	{

		$API_KEY = get_option("geotagphoto_api_key");

		echo '<script type="text/javascript" src="' . get_bloginfo('wpurl') . '/wp-content/plugins/geotagphoto/geotagphoto.js" ></script>'."\n";

		echo '<script type="text/javascript" src="' . get_bloginfo(wpurl) . '/wp-includes/js/jquery/jquery.js"></script>'."\n";

		echo '<script type="text/javascript" src="' . get_bloginfo(wpurl) . '/wp-includes/js/thickbox/thickbox.js"></script>'."\n";

		echo '<style type="text/css" media="all">@import "' . get_bloginfo(wpurl) . '/wp-includes/js/thickbox/thickbox.css";</style>'."\n";

		echo '<script src="http://maps.google.com/maps?file=api&v=1&key=' . $API_KEY . '" type="text/javascript"></script>';

	}

	

	function thickboxmap_div() 

	{

		echo '<div id="test_map" style="display:none" ></div>';	

	}





	function geotagphoto_menu() 

	{

	  add_options_page('GeotagPhoto Options', 'GeotagPhoto', 8, 'geotagphoto.php', 'geotagphoto_options');

	}



	function geotagphoto_options() 

	{

		global $geotagphoto_options;

		$geotagphoto_api_key = get_option("geotagphoto_api_key");
		$geotagphoto_box = get_option("geotagphoto_box");
		$geotagphoto_icon_pos = get_option("geotagphoto_icon_pos");
		$geotagphoto_icon = get_option("geotagphoto_icon");
		$geotagphoto_map_width = get_option("geotagphoto_map_width"); 
		$geotagphoto_map_height = get_option("geotagphoto_map_height");
		$geotagphoto_map_control = get_option("geotagphoto_map_control"); 
		$geotagphoto_map_control_pos = get_option("geotagphoto_map_control_pos");
		$geotagphoto_map_type = get_option("geotagphoto_map_type"); 
		$geotagphoto_map_type_sel = get_option("geotagphoto_map_type_sel");
		$geotagphoto_map_zoom = get_option("geotagphoto_map_zoom"); 


	    echo '<div class="wrap">';

	    echo '<form method="post" action="options.php">';

	    wp_nonce_field('update-options');

	    echo "	<table class='form-table'>

					<tr valign='top'>

						<th scope='row'><b>Google API Key</b></th>

						<td><input name='geotagphoto_api_key' type='text' value='".$geotagphoto_api_key."' size='150' ";

							if (empty($geotagphoto_api_key)) {echo "style='border: 1px solid #d54e21; background-color: #ffebe8;'";}

							echo " /><br />

							You need a unique Google API Key for your website to display Google Maps. If you don't have one yet, <a href='http://code.google.com/apis/maps/signup.html' target='_blank'>sign up</a> to get one!</td>";

echo '				</tr>

					<tr>
					<th scope="row"><b>ThickBox</b></th>
					<td>
                            <INPUT TYPE=CHECKBOX NAME="geotagphoto_box" value="ThickBoxAll"'; if( $geotagphoto_box == "ThickBoxAll" ){ echo "checked"; } echo ' >Add Thickbox to all photos (not just tagged ones)
                    <td></tr>
					';
					
echo '				<tr>
					<th scope="row"><b>Icon</b></th>
					<td>
                                        <b><ul>Position</b></ul>
                        <input type="radio" name="geotagphoto_icon_pos" value="TopLeft"'; if( $geotagphoto_icon_pos == "TopLeft" ){ echo "checked"; } echo '/> Top Left
						<br />
						<input type="radio" name="geotagphoto_icon_pos" value="TopRight"'; if( $geotagphoto_icon_pos == "TopRight" ){ echo "checked"; } echo ' /> Top Right
						<br />
						<input type="radio" name="geotagphoto_icon_pos" value="BottomLeft"'; if( $geotagphoto_icon_pos == "BottomLeft" ){ echo "checked"; } echo ' /> Bottom Left
						<br />
						<input type="radio" name="geotagphoto_icon_pos" value="BottomRight"'; if( $geotagphoto_icon_pos == "BottomRight" ){ echo "checked"; } echo ' /> Bottom Right
						<br></br>
						<br></br>
                                                <b><ul>Image</b></ul>
						<input name="geotagphoto_icon" type="text" value=" '; if( empty( $geotagphoto_icon ) ){  echo get_bloginfo('wpurl') . "/wp-content/plugins/geotagphoto/images/marker.png"; }else{ echo $geotagphoto_icon; } echo '" size="150"/>
                                                <br>Leave This blank to revert back to default icon.

                    <td></tr>';

echo '				</tr>

					<tr>
					<th scope="row"><b>Map</b></th>
					<td>
						<b><ul>Map Width</b></ul>
						<input name="geotagphoto_map_width" type="text" value=" '; if( empty( $geotagphoto_map_width ) ){  echo "550"; }else{ echo $geotagphoto_map_width; } echo '" size="150"/>
                        <br></br>
                         
                        <b><ul>Map Height</b></ul>
						<input name="geotagphoto_map_height" type="text" value=" '; if( empty( $geotagphoto_map_height ) ){  echo "400"; }else{ echo $geotagphoto_map_height; } echo '" size="150"/>
						<br></br> 

                        <b><ul>Map Controls</b></ul>
						<input type="radio" name="geotagphoto_map_control" value="GLargeMapControl3D"'; if( $geotagphoto_map_control == "GLargeMapControl3D" || empty( $geotagphoto_map_control ) ){ echo "checked"; } echo '/> a large pan/zoom control as now used on Google Maps.
						<br></br> 
						<input type="radio" name="geotagphoto_map_control" value="GLargeMapControl"'; if( $geotagphoto_map_control == "GLargeMapControl" ){ echo "checked"; } echo ' /> a simpler large pan/zoom control.
						<br></br> 
						<input type="radio" name="geotagphoto_map_control" value="GSmallMapControl"'; if( $geotagphoto_map_control == "GSmallMapControl" ){ echo "checked"; } echo ' /> a smaller pan/zoom control. 	
						<br></br> 		

						<br></br> 
                        <b><ul>Map Control Position</b></ul>	
						<input type="radio" name="geotagphoto_map_control_pos" value="G_ANCHOR_TOP_RIGHT"'; if( $geotagphoto_map_control_pos == "G_ANCHOR_TOP_RIGHT" || empty( $geotagphoto_map_control_pos ) ){ echo "checked"; } echo '/> Top Right
						<br></br> 
						<input type="radio" name="geotagphoto_map_control_pos" value="G_ANCHOR_TOP_LEFT"'; if( $geotagphoto_map_control_pos == "G_ANCHOR_TOP_LEFT" ){ echo "checked"; } echo ' /> Top Left
						<br></br> 
						<input type="radio" name="geotagphoto_map_control_pos" value="G_ANCHOR_BOTTOM_RIGHT"'; if( $geotagphoto_map_control_pos == "G_ANCHOR_BOTTOM_RIGHT" ){ echo "checked"; } echo ' /> Bottom Right
						<br></br> 	
						<input type="radio" name="geotagphoto_map_control_pos" value="G_ANCHOR_BOTTOM_LEFT"'; if( $geotagphoto_map_control_pos == "G_ANCHOR_BOTTOM_LEFT" ){ echo "checked"; } echo ' /> Bottom Left
						<br></br> 
						
						<br></br> 
						<b><ul>Map Type</b></ul>	
						<input type="radio" name="geotagphoto_map_type" value="G_NORMAL_MAP"'; if( $geotagphoto_map_type == "G_NORMAL_MAP" || empty( $geotagphoto_map_type ) ){ echo "checked"; } echo '/> Normal
						<br></br> 
						<input type="radio" name="geotagphoto_map_type" value="G_SATELLITE_MAP"'; if( $geotagphoto_map_type == "G_SATELLITE_MAP" ){ echo "checked"; } echo ' /> Satellite
						<br></br> 
						<input type="radio" name="geotagphoto_map_type" value="G_HYBRID_MAP"'; if( $geotagphoto_map_type == "G_HYBRID_MAP" ){ echo "checked"; } echo ' /> Hybrid
						<br></br> 	
						<input type="radio" name="geotagphoto_map_type" value="G_PHYSICAL_MAP"'; if( $geotagphoto_map_type == "G_PHYSICAL_MAP" ){ echo "checked"; } echo ' /> Physical
						<br></br> 

						<br></br> 
						<b><ul>Map Control Type Selection</b></ul>	
						<INPUT TYPE=CHECKBOX NAME="geotagphoto_map_type_sel" value="1"'; if( $geotagphoto_map_type_sel == 1 ){ echo "checked"; } echo ' > Add Map Type Control
						<br></br> 
						
						<br></br> 
						<b><ul>Map Zoom Level</b></ul>
						
						<select name="geotagphoto_map_zoom">
						<option value="0" '; if( $geotagphoto_map_zoom == 0 ){ echo "selected"; } echo'>0</option>
						<option value="1" '; if( $geotagphoto_map_zoom == 1 ){ echo "selected"; } echo'>1</option>
						<option value="2" '; if( $geotagphoto_map_zoom == 2 ){ echo "selected"; } echo'>2</option>
						<option value="3" '; if( $geotagphoto_map_zoom == 3 ){ echo "selected"; } echo'>3</option>
						<option value="4" '; if( $geotagphoto_map_zoom == 4 ){ echo "selected"; } echo'>4</option>
						<option value="5" '; if( $geotagphoto_map_zoom == 5 ){ echo "selected"; } echo'>5</option>
						<option value="6" '; if( $geotagphoto_map_zoom == 6 ){ echo "selected"; } echo'>6</option>
						<option value="7" '; if( $geotagphoto_map_zoom == 7 ){ echo "selected"; } echo'>7</option>
						<option value="8" '; if( $geotagphoto_map_zoom == 8 ){ echo "selected"; } echo'>8</option>
						<option value="9" '; if( $geotagphoto_map_zoom == 9 ){ echo "selected"; } echo'>9</option>
						<option value="10" '; if( $geotagphoto_map_zoom == 10 ){ echo "selected"; } echo'>10</option>
						<option value="11" '; if( $geotagphoto_map_zoom == 11 ){ echo "selected"; } echo'>11</option>
						<option value="12" '; if( $geotagphoto_map_zoom == 12 ){ echo "selected"; } echo'>12</option>
						<option value="13" '; if( $geotagphoto_map_zoom == 13 ){ echo "selected"; } echo'>13</option>
						<option value="14" '; if( $geotagphoto_map_zoom == 14 ){ echo "selected"; } echo'>14</option>
						<option value="15" '; if( $geotagphoto_map_zoom == 15 ){ echo "selected"; } echo'>15</option>
						<option value="16" '; if( $geotagphoto_map_zoom == 16 ){ echo "selected"; } echo'>16</option>
						<option value="17" '; if( $geotagphoto_map_zoom == 17 ){ echo "selected"; } echo'>17</option>
						<option value="18" '; if( $geotagphoto_map_zoom == 18 ){ echo "selected"; } echo'>18</option>
						<option value="19" '; if( $geotagphoto_map_zoom == 19 ){ echo "selected"; } echo'>19</option>
						</select>
						
                    <td></tr>
					';


echo "
				</table>

				<p class='submit'>

					<input type='submit' name='submit' value='Save Changes' class='button-primary' />

					<input type='hidden' name='action' value='update' />

					<input type='hidden' name='page_options' value='geotagphoto_api_key,geotagphoto_box,geotagphoto_icon_pos,geotagphoto_icon,geotagphoto_map_width,geotagphoto_map_height,geotagphoto_map_control,geotagphoto_map_control_pos,geotagphoto_map_type,geotagphoto_map_type_sel,geotagphoto_map_zoom' />
					
				</p>

		</form>";



	  echo '</div>';

	}

?>
